      subroutine initloop
      implicit none
      double precision L, Lj, Ls, g11, g11sq, g12, g11g21, g22
      double precision g21, g31, g32, g21sq, g21g31, g31sq
      double precision ld1, ld2, ld3, ld4, zt3
      DOUBLE PRECISION PRX(10), PRD(10) !JG
      COMMON /ddicontrol/ PRX, PRD !JG
      common /inte/ g11, g11sq, g12, g11g21, g22
      common /inte/ g21, g31, g32, g21sq, g21g31, g31sq
      include "var.inc"

      PRX=0.d0
      PRD=0.d0
      floop=0.d0

      ld1=dlog(deltas)
      ld2=dlog(deltas)**2/2.d0
      ld3=dlog(deltas)**3/3.d0
      ld4=dlog(deltas)**4/4.d0

      zt3=1.20206d0

      L = dlog(rscale)

      Lj = -2*L

      Ls = -dlog(1.d0-mw**2/mt**2)-L

c do interpolation of all the coefficients

      call interpol

c  end of interpolation

      if(order.eq.2) then

         floop(1) = 2*g11 + (cf*(42 - 18*Lj + 12*Lj**2 + 
     -       6*(-4*ld2 + ld1*(-7 + 4*Lj - 8*Ls)) - 24*Ls - 
     -       24*Ls**2 - 7*Pi**2))/6.


         floop(2) = 2*g21


         floop(3) = 2*g31

      elseif(order.eq.3) then

         floop(1) = (50521*ca*cf)/648. + (205*cf**2)/8. + 14*cf*g11 + g11sq + 
     -  2*g12 - (905*ca*cf*ld1)/18. - (101*cf**2*ld1)/2. - 
     -  14*cf*g11*ld1 + (95*ca*cf*ld2)/9. + 21*cf**2*ld2 - 
     -  8*cf*g11*ld2 + 22*ca*cf*ld3 + 42*cf**2*ld3 + 
     -  8*cf**2*ld4 - (3155*ca*cf*Lj)/54. - (45*cf**2*Lj)/2. - 
     -  6*cf*g11*Lj + (367*ca*cf*ld1*Lj)/9. + 49*cf**2*ld1*Lj + 
     -  8*cf*g11*ld1*Lj - (44*ca*cf*ld2*Lj)/3. - 
     -  44*cf**2*ld2*Lj - 24*cf**2*ld3*Lj + 
     -  (367*ca*cf*Lj**2)/18. + (37*cf**2*Lj**2)/2. + 
     -  4*cf*g11*Lj**2 - (22*ca*cf*ld1*Lj**2)/3. - 
     -  26*cf**2*ld1*Lj**2 + 8*cf**2*ld2*Lj**2 - 
     -  (22*ca*cf*Lj**3)/9. - 6*cf**2*Lj**3 + 8*cf**2*ld1*Lj**3 + 
     -  2*cf**2*Lj**4 + (220*ca*cf*Ls)/27. - 28*cf**2*Ls - 
     -  8*cf*g11*Ls - (272*ca*cf*ld1*Ls)/9. - 28*cf**2*ld1*Ls - 
     -  16*cf*g11*ld1*Ls + (176*ca*cf*ld2*Ls)/3. + 
     -  128*cf**2*ld2*Ls + 48*cf**2*ld3*Ls + 12*cf**2*Lj*Ls + 
     -  8*cf**2*ld1*Lj*Ls - 64*cf**2*ld2*Lj*Ls - 
     -  8*cf**2*Lj**2*Ls - 16*cf**2*ld1*Lj**2*Ls - 
     -  (136*ca*cf*Ls**2)/9. - 20*cf**2*Ls**2 - 8*cf*g11*Ls**2 + 
     -  (88*ca*cf*ld1*Ls**2)/3. + 60*cf**2*ld1*Ls**2 + 
     -  80*cf**2*ld2*Ls**2 + 12*cf**2*Lj*Ls**2 - 
     -  16*cf**2*ld1*Lj*Ls**2 - 8*cf**2*Lj**2*Ls**2 + 
     -  (88*ca*cf*Ls**3)/9. + 16*cf**2*Ls**3 + 
     -  32*cf**2*ld1*Ls**3 + 8*cf**2*Ls**4 - 
     -  (1259*ca*cf*Pi**2)/108. - (47*cf**2*Pi**2)/3. - 
     -  (7*cf*g11*Pi**2)/3. + (34*ca*cf*ld1*Pi**2)/9. + 
     -  (11*cf**2*ld1*Pi**2)/2. + (4*ca*cf*ld2*Pi**2)/3. + 
     -  2*cf**2*ld2*Pi**2 + (22*ca*cf*Lj*Pi**2)/9. + 
     -  (61*cf**2*Lj*Pi**2)/6. - (4*ca*cf*ld1*Lj*Pi**2)/3. - 
     -  2*cf**2*ld1*Lj*Pi**2 - (2*ca*cf*Lj**2*Pi**2)/3. - 
     -  (11*cf**2*Lj**2*Pi**2)/3. + (4*ca*cf*Ls*Pi**2)/3. - 
     -  (14*cf**2*Ls*Pi**2)/3. + (8*ca*cf*ld1*Ls*Pi**2)/3. + 
     -  4*cf**2*ld1*Ls*Pi**2 + (16*cf**2*Lj*Ls*Pi**2)/3. + 
     -  (4*ca*cf*Ls**2*Pi**2)/3. - (2*cf**2*Ls**2*Pi**2)/3. + 
     -  (5*ca*cf*Pi**4)/18. + (401*cf**2*Pi**4)/360. - 
     -  (4073*cf*nf*tr)/162. + (170*cf*ld1*nf*tr)/9. - 
     -  (52*cf*ld2*nf*tr)/9. - 8*cf*ld3*nf*tr + 
     -  (494*cf*Lj*nf*tr)/27. - (116*cf*ld1*Lj*nf*tr)/9. + 
     -  (16*cf*ld2*Lj*nf*tr)/3. - (58*cf*Lj**2*nf*tr)/9. + 
     -  (8*cf*ld1*Lj**2*nf*tr)/3. + (8*cf*Lj**3*nf*tr)/9. + 
     -  (16*cf*Ls*nf*tr)/27. + (64*cf*ld1*Ls*nf*tr)/9. - 
     -  (64*cf*ld2*Ls*nf*tr)/3. + (32*cf*Ls**2*nf*tr)/9. - 
     -  (32*cf*ld1*Ls**2*nf*tr)/3. - (32*cf*Ls**3*nf*tr)/9. + 
     -  (73*cf*nf*Pi**2*tr)/27. - (8*cf*ld1*nf*Pi**2*tr)/9. - 
     -  (8*cf*Lj*nf*Pi**2*tr)/9. - (313*ca*cf*zt3)/9. + 
     -  22*cf**2*zt3 + 4*ca*cf*ld1*zt3 - 8*cf**2*ld1*zt3 + 
     -  40*ca*cf*Lj*zt3 - 40*cf**2*Lj*zt3 - 36*ca*cf*Ls*zt3 + 
     -  32*cf**2*Ls*zt3 - (4*cf*nf*tr*zt3)/9.


         floop(2) = 2*g11g21 + 2*g22 - 
     -  (cf*g21*(-42 + 18*Lj - 12*Lj**2 + 24*Ls + 24*Ls**2 + 
     -       6*(4*ld2 + ld1*(7 - 4*Lj + 8*Ls)) + 7*Pi**2))/3.


         floop(3) = 2*g11*g31 + 2*g32 - 
     -  (cf*g31*(-42 + 18*Lj - 12*Lj**2 + 24*Ls + 24*Ls**2 + 
     -       6*(4*ld2 + ld1*(7 - 4*Lj + 8*Ls)) + 7*Pi**2))/3.


         floop(4) = g21sq


         floop(5) = 2*g21g31


         floop(6) = g31sq

         endif


      end subroutine


      DOUBLE PRECISION FUNCTION DDILOG(X)

      DOUBLE PRECISION X,Y,T,S,A,PI3,PI6,ZERO,ONE,HALF,MALF,MONE,MTWO
      DOUBLE PRECISION C(0:18),H,ALFA,B0,B1,B2
      DOUBLE PRECISION PRX(10), PRD(10) !JG
      INTEGER I !JG
      COMMON /ddicontrol/ PRX, PRD !JG

      DATA ZERO /0.0D0/, ONE /1.0D0/
      DATA HALF /0.5D0/, MALF /-0.5D0/, MONE /-1.0D0/, MTWO /-2.0D0/
      DATA PI3 /3.28986 81336 96453D0/, PI6 /1.64493 40668 48226D0/

      DATA C( 0) / 0.42996 69356 08137 0D0/
      DATA C( 1) / 0.40975 98753 30771 1D0/
      DATA C( 2) /-0.01858 84366 50146 0D0/
      DATA C( 3) / 0.00145 75108 40622 7D0/
      DATA C( 4) /-0.00014 30418 44423 4D0/
      DATA C( 5) / 0.00001 58841 55418 8D0/
      DATA C( 6) /-0.00000 19078 49593 9D0/
      DATA C( 7) / 0.00000 02419 51808 5D0/
      DATA C( 8) /-0.00000 00319 33412 7D0/
      DATA C( 9) / 0.00000 00043 45450 6D0/
      DATA C(10) /-0.00000 00006 05784 8D0/
      DATA C(11) / 0.00000 00000 86121 0D0/
      DATA C(12) /-0.00000 00000 12443 3D0/
      DATA C(13) / 0.00000 00000 01822 6D0/
      DATA C(14) /-0.00000 00000 00270 1D0/
      DATA C(15) / 0.00000 00000 00040 4D0/
      DATA C(16) /-0.00000 00000 00006 1D0/
      DATA C(17) / 0.00000 00000 00000 9D0/
      DATA C(18) /-0.00000 00000 00000 1D0/


      do i=1, 10
      if((prx(i)-x).eq.0.d0) then
      ddilog=prd(i)
      goto 100
      endif
      enddo

      IF(X .EQ. ONE) THEN
       DDILOG=PI6
       RETURN
      ELSE IF(X .EQ. MONE) THEN
       DDILOG=MALF*PI6
       RETURN
      END IF
      T=-X
      IF(T .LE. MTWO) THEN
       Y=MONE/(ONE+T)
       S=ONE
       A=-PI3+HALF*(LOG(-T)**2-LOG(ONE+ONE/T)**2)
      ELSE IF(T .LT. MONE) THEN
       Y=MONE-T
       S=MONE
       A=LOG(-T)
       A=-PI6+A*(A+LOG(ONE+ONE/T))
      ELSE IF(T .LE. MALF) THEN
       Y=(MONE-T)/T
       S=ONE
       A=LOG(-T)
       A=-PI6+A*(MALF*A+LOG(ONE+T))
      ELSE IF(T .LT. ZERO) THEN
       Y=-T/(ONE+T)
       S=MONE
       A=HALF*LOG(ONE+T)**2
      ELSE IF(T .LE. ONE) THEN
       Y=T
       S=ONE
       A=ZERO
      ELSE
       Y=ONE/T
       S=MONE
       A=PI6+HALF*LOG(T)**2
      END IF

      H=Y+Y-ONE
      ALFA=H+H
      B1=ZERO
      B2=ZERO
      DO 1 I = 18,0,-1
      B0=C(I)+ALFA*B1-B2
      B2=B1
    1 B1=B0
      DDILOG=-(S*(B0-H*B2)+A)

      do i=1, 9
      prd(i)=prd(i+1)
      prx(i)=prx(i+1)
      enddo

      prx(10)=x
      prd(10)=ddilog

100   RETURN
      END

      subroutine interpol
      implicit none
      double precision L, g11, g11sq, g12, g11g21, g22
      double precision g21, g31, g32, g21sq, g21g31, g31sq
      double precision ddilog, x, x0(5), fiveinte
      double precision p12(5), p22(5), p32(5)
      common /inte/ g11, g11sq, g12, g11g21, g22
      common /inte/ g21, g31, g32, g21sq, g21g31, g31sq
      external ddilog, fiveinte
      include "var.inc"
       
      L = dlog(rscale)
      x = mw**2/mt**2
c interpolation mass
      x0(1) = (80.385d0/171.5d0)**2
      x0(2) = (80.385d0/172.5d0)**2
      x0(3) = (80.385d0/173.5d0)**2
      x0(4) = (80.385d0/174.5d0)**2
      x0(5) = (80.385d0/175.5d0)**2

      g11= -6*CF - 5*CF*L - 2*CF*L**2 - (5*CF*Pi**2)/12. + 
     -  3*CF*dlog(1 - x) + 4*CF*L*dlog(1 - x) - (CF*dlog(1 - x))/x - 
     -  2*CF*dlog(1 - x)**2 + 2*CF*dlog(1 - x)*dlog(x) + 
     -  2*CF*ddilog(1 - x)

      g21= (2*CF)/x + (2*CF*dlog(1 - x))/x**2 - (2*CF*dlog(1 - x))/x

      g31=(-2*CF)/x - (2*CF*dlog(1 - x))/x**2 + (4*CF*dlog(1 - x))/x

      if(order.eq.3) then

      g11sq=(-6*CF - 5*CF*L - 2*CF*L**2 - (5*CF*Pi**2)/12. + 
     -    3*CF*dlog(1 - x) + 4*CF*L*dlog(1 - x) - (CF*dlog(1 - x))/x - 
     -    2*CF*dlog(1 - x)**2 + 2*CF*dlog(1 - x)*dlog(x) + 
     -    2*CF*ddilog(1 - x))**2


      g11g21=((2*CF)/x + (2*CF*dlog(1 - x))/x**2 - (2*CF*dlog(1 - x))/x)*
     -  (-6*CF - 5*CF*L - 2*CF*L**2 - (5*CF*Pi**2)/12. + 
     -    3*CF*dlog(1 - x) + 4*CF*L*dlog(1 - x) - (CF*dlog(1 - x))/x - 
     -    2*CF*dlog(1 - x)**2 + 2*CF*dlog(1 - x)*dlog(x) + 
     -    2*CF*ddilog(1 - x))

      g21sq=((2*CF)/x + (2*CF*dlog(1 - x))/x**2 - (2*CF*dlog(1 - x))/x)**2

      g21g31=((2*CF)/x + (2*CF*dlog(1 - x))/x**2 - (2*CF*dlog(1 - x))/x)*
     -  ((-2*CF)/x - (2*CF*dlog(1 - x))/x**2 + (4*CF*dlog(1 - x))/x)

      g31sq=((-2*CF)/x - (2*CF*dlog(1 - x))/x**2 + (4*CF*dlog(1 - x))/x)**2


c for 1st point x0(1)

       p12(1)=-0.15513936616167*CF - 68.5071282056517*CA*CF + 
     -  18.742055672450192*CF**2 - 69.40702921272455*CA*CF*L + 
     -  31.496570797070206*CF**2*L - 30.280867282038308*CA*CF*L**2 + 
     -  32.00738927583982*CF**2*L**2 - 
     -  4.888888888888889*CA*CF*L**3 + 
     -  11.984571633023084*CF**2*L**3 + 2.*CF**2*L**4 + 
     -  21.140179464811048*CF*nf + 18.391133974421432*CF*L*nf + 
     -  6.217079433229917*CF*L**2*nf + 0.8888888888888888*CF*L**3*nf


        p22(1)= 0.3010973862732982*CF + 5.196785759023214*CA*CF + 
     -  6.702070978448546*CF**2 + 7.938489038559936*CA*CF*L - 
     -  6.486776627767398*CF**2*L - 2.1650424650617985*CF**2*L**2 - 
     -  1.2812999089910022*CF*nf - 1.4433616433745335*CF*L*nf


         p32(1)=-0.36974970455466405*CF - 54.284192853116565*CA*CF + 
     -  16.676622203507122*CF**2 - 24.49948421586778*CA*CF*L + 
     -  20.019260697080842*CF**2*L + 6.681677513418483*CF**2*L**2 + 
     -  9.34263325526371*CF*nf + 4.454451675612323*CF*L*nf

c for 2nd point x0(2)

         p12(2)=-0.15591264426046791*CF - 68.28315780628415*CA*CF + 
     -  18.614156192694622*CF**2 - 69.22890569477067*CA*CF*L + 
     -  31.304030389039006*CF**2*L - 30.233206224339064*CA*CF*L**2 + 
     -  31.89573219378272*CF**2*L**2 - 
     -  4.888888888888889*CA*CF*L**3 + 
     -  11.95857469245986*CF**2*L**3 + 2.*CF**2*L**4 + 
     -  21.081809712420913*CF*nf + 18.354123887619366*CF*L*nf + 
     -  6.208413786375509*CF*L**2*nf + 0.8888888888888888*CF*L**3*nf


         p22(2)=0.301008852165495*CF + 5.18745747745993*CA*CF + 
     -  6.7063318595098735*CF**2 + 7.93059360136062*CA*CF*L - 
     -  6.4662679048237806*CF**2*L - 2.1628891640074386*CF**2*L**2 - 
     -  1.279012632495082*CF*nf - 1.4419261093382936*CF*L*nf


         p32(2)=-0.3696527338898363*CF - 54.180909786574375*CA*CF + 
     -  16.600743493447226*CF**2 - 24.465804553439966*CA*CF*L + 
     -  19.948373942961563*CF**2*L + 6.6724921509381705*CF**2*L**2 + 
     -  9.324064667724706*CF*nf + 4.448328100625448*CF*L*nf

c for 3rd point x0(3)

         p12(3)=-0.15667213688099935*CF - 68.064221738616*CA*CF + 
     -  18.489389218898168*CF**2 - 69.05463431914437*CA*CF*L + 
     -  31.11602202150149*CF**2*L - 30.18651731459544*CA*CF*L**2 + 
     -  31.786576129777053*CF**2*L**2 - 
     -  4.888888888888889*CA*CF*L**3 + 
     -  11.933108014417886*CF**2*L**3 + 2.*CF**2*L**4 + 
     -  21.02472539548529*CF*nf + 18.317908506429244*CF*L*nf + 
     -  6.199924893694851*CF*L**2*nf + 0.8888888888888888*CF*L**3*nf


         p22(3)=0.3009219676541548*CF + 5.178323853280176*CA*CF + 
     -  6.710446965310894*CF**2 + 7.922857991355443*CA*CF*L - 
     -  6.44620364957305*CF**2*L - 2.160779452187846*CF**2*L**2 - 
     -  1.276773386942068*CF*nf - 1.4405196347918956*CF*L*nf


         p32(3)=-0.36955756491008174*CF - 54.0798738823928*CA*CF + 
     -  16.52669210119211*CF**2 - 24.432835521394495*CA*CF*L + 
     -  19.87906809377092*CF**2*L + 6.663500596743955*CF**2*L**2 + 
     -  9.305900433487654*CF*nf + 4.442333731162635*CF*L*nf

c for 4th point x0(4)

         p12(4)=-0.15741817311648987*CF - 67.8501624398913*CA*CF + 
     -  18.36764810005343*CF**2 - 68.88409937578625*CA*CF*L + 
     -  30.932397320031463*CF**2*L - 30.140773149646307*CA*CF*L**2 + 
     -  31.67984336822262*CF**2*L**2 - 
     -  4.888888888888889*CA*CF*L**3 + 
     -  11.908156651718357*CF**2*L**3 + 2.*CF**2*L**4 + 
     -  20.968887104133987*CF*nf + 18.282464134051573*CF*L*nf + 
     -  6.191607772795008*CF*L**2*nf + 0.8888888888888888*CF*L**3*nf

         p22(4)=0.3008366911710212*CF + 5.169379277493476*CA*CF + 
     -  6.714422428466833*CF**2 + 7.915277757440435*CA*CF*L - 
     -  6.426570509826888*CF**2*L - 2.158712115665569*CF**2*L**2 - 
     -  1.2745807785339522*CF*nf - 1.4391414104437121*CF*L*nf

         p32(4)=-0.3694641523688631*CF - 53.981017191816136*CA*CF + 
     -  16.4544068758928*CF**2 - 24.400556345337748*CA*CF*L + 
     -  19.811294137456507*CF**2*L + 6.6546971850921075*CF**2*L**2 + 
     -  9.288128317024174*CF*nf + 4.436464790061404*CF*L*nf

c for 5th point x0(5)

         p12(5)=-0.1581510721866195*CF - 67.6408287199553*CA*CF + 
     -  18.248830847426348*CF**2 - 68.71718964745101*CA*CF*L + 
     -  30.7530141625748*CF**2*L - 30.09594732429943*CA*CF*L**2 + 
     -  31.575459303677782*CF**2*L**2 - 
     -  4.888888888888889*CA*CF*L**3 + 
     -  11.88370620152915*CF**2*L**3 + 2.*CF**2*L**4 + 
     -  20.91425699196983*CF*nf + 18.247767987383376*CF*L*nf + 
     -  6.183457622731939*CF*L**2*nf + 0.8888888888888888*CF*L**3*nf


         p22(5)=0.3007529824757782*CF + 5.160618349219021*CA*CF + 
     -  6.718264074441322*CF**2 + 7.907848607866285*CA*CF*L - 
     -  6.407355650594695*CF**2*L - 2.1566859839635306*CF**2*L**2 - 
     -  1.2724334655714031*CF*nf - 1.4377906559756877*CF*L*nf

         p32(5)=-0.36937245246059547*CF - 53.88427442222974*CA*CF + 
     -  16.38382929533782*CF**2 - 24.368947035300252*CA*CF*L + 
     -  19.7450050232818*CF**2*L + 6.646076464172795*CF**2*L**2 + 
     -  9.270736561335458*CF*nf + 4.430717642781863*CF*L*nf

c do interpolation

        g12= fiveinte(x0, p12, x)  
        g22= fiveinte(x0, p22, x)  
        g32= fiveinte(x0, p32, x) 

      endif 

      end subroutine


      double precision function fiveinte(xint, yint, x)
      implicit none
      double precision xint(5), yint(5), coe(0:4), x

      coe=0.d0

      coe(0)=yint(1)

      coe(1)=(yint(2)-coe(0))/(xint(2)-xint(1))

      coe(2)=(yint(3)-coe(0)-coe(1)*(xint(3)-xint(1)))
     -    /((xint(3)-xint(1))*(xint(3)-xint(2)))

      coe(3)=(yint(4)-coe(0)-coe(1)*(xint(4)-xint(1))
     -    -coe(2)*(xint(4)-xint(1))*(xint(4)-xint(2)))
     -    /((xint(4)-xint(1))*(xint(4)-xint(2))*(xint(4)-xint(3)))

      coe(4)=(yint(5)-coe(0)-coe(1)*(xint(5)-xint(1))
     -    -coe(2)*(xint(5)-xint(1))*(xint(5)-xint(2))
     -  -coe(3)*(xint(5)-xint(1))*(xint(5)-xint(2))*(xint(5)-xint(3)))
     -    /((xint(5)-xint(1))*(xint(5)-xint(2))*(xint(5)-xint(3))
     -     *(xint(5)-xint(4)))

      fiveinte=coe(0)+coe(1)*(x-xint(1))+coe(2)*(x-xint(1))*(x-xint(2))
     -   +coe(3)*(x-xint(1))*(x-xint(2))*(x-xint(3))
     -   +coe(4)*(x-xint(1))*(x-xint(2))*(x-xint(3))*(x-xint(4))

      end function
