      subroutine top24treesqamp(p,matrixsq)
      implicit none
      integer i
      double precision ampsq(3), p(0:3, 6), matrixsq

      do i=1, 3
      ampsq(i)=0.d0
      enddo

      call top24treegg(p, ampsq(1))
      call top24treeqq(p, ampsq(2))
      call top24treebb(p, ampsq(3))
  
      matrixsq=ampsq(1)+ampsq(2)+ampsq(3)

      end subroutine



      subroutine top24treegg(p,matrixsq)

c  sumed over spin and colors and averaged over initial spin ,color

      implicit none
      double precision p(0:3,6), color(2, 2)
      double complex f1(6), f2(6), f3(6), f4(6), f5(6), f6(6), i1(6)
      double complex vertex(2), ampsub(8), i3(6), i2(6)
      double precision matrixsq, averagefactor, zero
      integer i,j,nh1,nh2,nh3,nh4,nh5,nh6
      parameter (zero=0.d0)
      double precision, dimension(2) :: zero2=(/0.d0, 0.d0/)
      include "para.inc" 
c color factor

      averagefactor=1.d0/2.d0/nc/2.d0
      color(1, 1)=cf**2*nc
      color(1, 2)=-cf/2.d0
      color(2, 1)=-cf/2.d0
      color(2, 2)=cf**2*nc

      matrixsq=0.d0

cc helicity amplitudes calculation
      do nh1=-1+por*(1+por), 1-por*(por-1),2
      do nh2=1,1
      do nh3=-1,-1
      do nh4=-1,-1
      do nh5=-1,1,2
      do nh6=-1,1,2

      call ixxxxx(p(0,1), mt, nh1, 1, f1)
      call ixxxxx(p(0,2), zero, nh2, -1, f2)
      call oxxxxx(p(0,3), zero, nh3, 1, f3)
      call oxxxxx(p(0,4), zero, nh4, 1, f4)
      call vxxxxx(p(0,5), zero, nh5, 1, f5)
      call vxxxxx(p(0,6), zero, nh6, 1, f6)

      vertex(1)=(0.d0, 0.d0)
      vertex(2)=(0.d0, 0.d0)
      call jioqqx(f2, f3, 1.d0, 0.d0, zero2, 0, i3)
c diagram 1

      call fvoqqx(f4, f6, 1.d0, 1.d0, zero, 1, i1)
      call fviqqx(f1, f5, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(i2, i1, i3, 1.d0, 0.d0, ampsub(1))
      
      vertex(1)=vertex(1)+ampsub(1)

      call fvoqqx(f4, f5, 1.d0, 1.d0, zero, 1, i1)
      call fviqqx(f1, f6, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(i2, i1, i3, 1.d0, 0.d0, ampsub(2))
      
      vertex(2)=vertex(2)+ampsub(2)

      call fviqqx(f1, f5, 1.d0, 1.d0, mt, 1, i1)
      call fviqqx(i1, f6, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(i2, f4, i3, 1.d0, 0.d0, ampsub(3))
      
      vertex(1)=vertex(1)+ampsub(3)

      call fviqqx(f1, f6, 1.d0, 1.d0, mt, 1, i1)
      call fviqqx(i1, f5, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(i2, f4, i3, 1.d0, 0.d0, ampsub(4))
      
      vertex(2)=vertex(2)+ampsub(4)

      call fvoqqx(f4, f6, 1.d0, 1.d0, zero, 1, i1)
      call fvoqqx(i1, f5, 1.d0, 1.d0, zero, 1, i2)
      call iovqqx(f1, i2, i3, 1.d0, 0.d0, ampsub(5))
      
      vertex(1)=vertex(1)+ampsub(5)

      call fvoqqx(f4, f5, 1.d0, 1.d0, zero, 1, i1)
      call fvoqqx(i1, f6, 1.d0, 1.d0, zero, 1, i2)
      call iovqqx(f1, i2, i3, 1.d0, 0.d0, ampsub(6))
      
      vertex(2)=vertex(2)+ampsub(6)

      call ggoxxx(f5, f6, i1)
      call fviqqx(f1, i1, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(i2, f4, i3, 1.d0, 0.d0, ampsub(7))

      vertex(1)=vertex(1)-ampsub(7)
      vertex(2)=vertex(2)+ampsub(7)
      
      call ggoxxx(f5, f6, i1)
      call fvoqqx(f4, i1, 1.d0, 1.d0, zero, 1, i2)
      call iovqqx(f1, i2, i3, 1.d0, 0.d0, ampsub(8))

      vertex(1)=vertex(1)-ampsub(8)
      vertex(2)=vertex(2)+ampsub(8)
     
      do i=1, 2 
      do j=1, 2 
      matrixsq=matrixsq+color(i, j)*dble(vertex(i)*conjg(vertex(j)))
      enddo
      enddo

      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
cc end of helicity calculations


      matrixsq=(4.d0*pi*alphas)**2*(2.d0*dsqrt(2.d0)*GF*mw**2)*
     -        averagefactor*matrixsq


      end subroutine


      subroutine top24treeqq(p,matrixsq)

c  sumed over spin and colors and averaged over initial spin ,color

      implicit none
      double precision p(0:3,6), color(2, 2)
      double complex f1(6), f2(6), f3(6), f4(6), f5(6), f6(6), i1(6)
      double complex vertex(2), ampsub(8), i3(6), i2(6)
      double precision matrixsq, averagefactor, zero
      integer i,j,nh1,nh2,nh3,nh4,nh5,nh6
      parameter (zero=0.d0)
      double precision, dimension(2) :: zero2=(/0.d0, 0.d0/)
      include "para.inc" 
c color factor

      averagefactor=1.d0/2.d0/nc
      color(1, 1)=tr**2*(nc**2-1.d0)

      matrixsq=0.d0

cc helicity amplitudes calculation
      do nh1=-1+por*(1+por), 1-por*(por-1),2
      do nh2=1,1
      do nh3=-1,-1
      do nh4=-1,-1
      do nh5=-1,1,2
      do nh6=-1,1,2

      call ixxxxx(p(0,1), mt, nh1, 1, f1)
      call ixxxxx(p(0,2), zero, nh2, -1, f2)
      call oxxxxx(p(0,3), zero, nh3, 1, f3)
      call oxxxxx(p(0,4), zero, nh4, 1, f4)
      call oxxxxx(p(0,5), zero, nh5, 1, f5)
      call ixxxxx(p(0,6), zero, nh6, -1, f6)

      vertex(1)=(0.d0, 0.d0)
      call jioqqx(f2, f3, 1.d0, 0.d0, zero2, 0, i3)
c diagram 1

      call jioqqx(f6, f5, 1.d0, 1.d0, zero2, 1, i1)
      call fviqqx(f1, i1, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(i2, f4, i3, 1.d0, 0.d0, ampsub(1))
      
      vertex(1)=vertex(1)+ampsub(1)

      call jioqqx(f6, f5, 1.d0, 1.d0, zero2, 1, i1)
      call fvoqqx(f4, i1, 1.d0, 1.d0, zero, 1, i2)
      call iovqqx(f1, i2, i3, 1.d0, 0.d0, ampsub(2))
      
      vertex(1)=vertex(1)+ampsub(2)

      do i=1, 1 
      do j=1, 1 
      matrixsq=matrixsq+color(i, j)*dble(vertex(i)*conjg(vertex(j)))
      enddo
      enddo

      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
cc end of helicity calculations


      matrixsq=(nf-1.d0)*(4.d0*pi*alphas)**2*(2.d0*dsqrt(2.d0)*GF*mw**2)*
     -        averagefactor*matrixsq


      end subroutine


      subroutine top24treebb(p,matrixsq)

c  sumed over spin and colors and averaged over initial spin ,color

      implicit none
      double precision p(0:3,6), color(2, 2)
      double complex f1(6), f2(6), f3(6), f4(6), f5(6), f6(6), i1(6)
      double complex vertex(2), ampsub(8), i3(6), i2(6)
      double precision matrixsq, averagefactor, zero
      integer i,j,nh1,nh2,nh3,nh4,nh5,nh6
      parameter (zero=0.d0)
      double precision, dimension(2) :: zero2=(/0.d0, 0.d0/)
      include "para.inc" 
c color factor

      averagefactor=1.d0/2.d0/nc/2.d0
      color(1, 1)=tr**2*(nc**2-1.d0)
      color(1, 2)=-cf/2.d0
      color(2, 1)=-cf/2.d0
      color(2, 2)=tr**2*(nc**2-1.d0)

      matrixsq=0.d0

cc helicity amplitudes calculation
      do nh1=-1+por*(1+por), 1-por*(por-1),2
      do nh2=1,1
      do nh3=-1,-1
      do nh4=-1,1,2
      do nh5=-1,1,2
      do nh6=-1,1,2

      call ixxxxx(p(0,1), mt, nh1, 1, f1)
      call ixxxxx(p(0,2), zero, nh2, -1, f2)
      call oxxxxx(p(0,3), zero, nh3, 1, f3)
      call oxxxxx(p(0,4), zero, nh4, 1, f4)
      call oxxxxx(p(0,5), zero, nh5, 1, f5)
      call ixxxxx(p(0,6), zero, nh6, -1, f6)

      vertex(1)=(0.d0, 0.d0)
      vertex(2)=(0.d0, 0.d0)
      call jioqqx(f2, f3, 1.d0, 0.d0, zero2, 0, i3)
c diagram 1

      call jioqqx(f6, f5, 1.d0, 1.d0, zero2, 1, i1)
      call fviqqx(f1, i1, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(i2, f4, i3, 1.d0, 0.d0, ampsub(1))
      
      vertex(1)=vertex(1)+ampsub(1)

      call jioqqx(f6, f5, 1.d0, 1.d0, zero2, 1, i1)
      call fvoqqx(f4, i1, 1.d0, 1.d0, zero, 1, i2)
      call iovqqx(f1, i2, i3, 1.d0, 0.d0, ampsub(2))
      
      vertex(1)=vertex(1)+ampsub(2)

      call jioqqx(f6, f4, 1.d0, 1.d0, zero2, 1, i1)
      call fviqqx(f1, i1, 1.d0, 1.d0, mt, 1, i2)
      call iovqqx(i2, f5, i3, 1.d0, 0.d0, ampsub(3))
      
      vertex(2)=vertex(2)-ampsub(3)

      call jioqqx(f6, f4, 1.d0, 1.d0, zero2, 1, i1)
      call fvoqqx(f5, i1, 1.d0, 1.d0, zero, 1, i2)
      call iovqqx(f1, i2, i3, 1.d0, 0.d0, ampsub(4))
      
      vertex(2)=vertex(2)-ampsub(4)

      do i=1, 2 
      do j=1, 2 
      matrixsq=matrixsq+color(i, j)*dble(vertex(i)*conjg(vertex(j)))
      enddo
      enddo

      enddo
      enddo
      enddo
      enddo
      enddo
      enddo
cc end of helicity calculations


      matrixsq=(4.d0*pi*alphas)**2*(2.d0*dsqrt(2.d0)*GF*mw**2)*
     -        averagefactor*matrixsq


      end subroutine
