* model_sm.h
* declarations for model_sm.F
* this file is part of FormCalc
* last modified 30 Nov 11 th


	RealType MZ, MZ2, MW, MW2, CW, CW2, SW2
	parameter (MZ = 91.1876D0, MZ2 = MZ**2)

	RealType GF, Alfa, Alfa2

	RealType ME, ME2, MM, MM2, ML, ML2
	parameter (ME = .510998910D-3, ME2 = ME**2)
	parameter (MM = 105.658367D-3, MM2 = MM**2)
	parameter (ML = 1776.82D-3, ML2 = ML**2)

	RealType MU, MU2, MC, MC2, MT, MT2
	parameter (MU = 53.8D-3, MU2 = MU**2)
	parameter (MC = 1.27D0, MC2 = MC**2)

	RealType MD, MD2, MS, MS2, MB, MB2, MBatMB
	parameter (MD = 53.8D-3, MD2 = MD**2)
	parameter (MS = 101D-3, MS2 = MS**2)
	parameter (MBatMB = 4.25D0)

	ComplexType CKM(3,3)
	RealType Mf(4,3), Mf2(4,3)
	RealType MH, MH2
	parameter (MH = 125.D0, MH2 = MH**2)
	RealType EL, GS, Alfas, Alfas2, SW

	common /sm_para1/ MW, MW2, MT, MT2, MB, MB2
	common /sm_para2/ GF, Alfa, Alfa2, CW, CW2, SW2, SW, EL 
	common /sm_para3/ Mf, Mf2
