      subroutine top22loopsqamp(p,matrixsq, ip)
      implicit none
      double precision p(0:3, 6), matrixsq, ME(6)
      double precision pref
      integer ip, j
      include "var.inc"

      matrixsq=0.d0
      call top22loopME(p, ME)

      if(ip.eq.1) then
      pref=alphas/4.d0/pi
      elseif(ip.eq.2) then
      pref=(alphas/4.d0/pi)**2
      else
      print *, "wrong ip in top loop!"
      stop
      endif

      do j=1, 6
      matrixsq=matrixsq+pref*floop(j)*ME(j)
      enddo

      end subroutine


      subroutine top22loopME(p,matrixsq)

c  sumed over spin and colors and averaged over initial spin ,color

      implicit none
      double precision p(0:3,6), colorfactor
      double complex f1(6), f2(6), f3(6), f4(6), f5(6), i1(6), i2(6)
      double complex vertex(3)
      double precision matrixsq(6), averagefactor, zero
      integer i,j,nh1,nh2,nh3,nh4,nh5
      parameter (zero=0.d0)
      double precision, dimension(2) :: zero2=(/0.d0, 0.d0/)
      include "var.inc" 
c color factor

      averagefactor=1.d0/2.d0/nc
      colorfactor=nc

      matrixsq=0.d0

cc helicity amplitudes calculation
      do nh1=-1+por*(1+por), 1-por*(por-1),2
      do nh2= 1,1
      do nh3=-1,-1
      do nh4=-1,-1

      call ixxxxx(p(0,1), mt, nh1, 1, f1)
      call ixxxxx(p(0,2), zero, nh2, -1, f2)
      call oxxxxx(p(0,3), zero, nh3, 1, f3)
      call oxxxxx(p(0,4), zero, nh4, 1, f4)

      call jioqqx(f2, f3, 1.d0, 0.d0, zero2, 0, i1)
c diagram 1

      call iovqqx(f1, f4, i1, 1.d0, 0.d0, vertex(1))
      call sio2vqq(f1, f4, i1, 0.d0, 1.d0, vertex(2))
      call sio3vqq(f1, f4, i1, 0.d0, 1.d0, vertex(3))
      
      matrixsq(1)=matrixsq(1)+4.d0*dble(vertex(1)*conjg(vertex(1)))
      matrixsq(2)=matrixsq(2)+4.d0*dble(vertex(1)*conjg(vertex(2)))/mt
      matrixsq(3)=matrixsq(3)+4.d0*dble(vertex(1)*conjg(vertex(3)))/mt
      matrixsq(4)=matrixsq(4)+4.d0*dble(vertex(2)*conjg(vertex(2)))/mt**2
      matrixsq(5)=matrixsq(5)+4.d0*dble(vertex(2)*conjg(vertex(3)))/mt**2
      matrixsq(6)=matrixsq(6)+4.d0*dble(vertex(3)*conjg(vertex(3)))/mt**2

      enddo
      enddo
      enddo
      enddo
cc end of helicity calculations


      matrixsq=(2.d0*dsqrt(2.d0)*GF*mw**2)*averagefactor*colorfactor*matrixsq/4.d0


      end subroutine
