      subroutine topewloopsqamp(p, results)

c  sumed over spin and colors and averaged over initial spin ,color

      implicit none
      integer i, helicities, flags
      double precision p(0:3,6), gm, gp
      double precision results(2), averagefactor, softphotonfactor
      double precision mm(4), ex(4), ey(4), ez(4), pp(4)
      external gm, gp, softphotonfactor
      data flags /3/
      include "para.inc" 
c color factor

      averagefactor=1.d0/2.d0/nc

      results=0.d0

      do i=1, 4
      mm(i)=gm(p(0, i))
      pp(i)=max(dsqrt(p(1, i)**2+p(2, i)**2+p(3, i)**2), 1d-12)
      ex(i)=p(1, i)/pp(i)
      ey(i)=p(2, i)/pp(i)
      ez(i)=p(3, i)/pp(i)
      call VecSet(i, mm(i), pp(i), ex(i), ey(i), ez(i))
      enddo

      if(por.eq.-1) then
              helicities=76106
      elseif(por.eq.1) then
              helicities=272714
      else
              helicities=338250
      endif


cc helicity amplitudes calculation

      call SquaredME(results, helicities, flags)
      results(2)=results(2)+results(1)*SoftPhotonFactor()

      results=results*averagefactor/(2.d0*dsqrt(2.d0)*GF*mw**2)
      
      if(flags.ne.2) flags=2

cc corrections for the GF&MW scheme, subtracting dr term

      results(2)=results(2)-results(1)*ewdR

      end subroutine
