      subroutine topewrealsqamp(p, results)

c  sumed over spin and colors and averaged over initial spin ,color

      implicit none
      integer i, helicities, flags
      double precision p(0:3,6), gm, gp
      double precision results(2), averagefactor
      double precision mm(5), ex(5), ey(5), ez(5), pp(5)
      external gm, gp
      data flags /1/
      double precision Divergence, mudim, lambda, muscale, ESOFTMAX
      integer epscoeff, Finite
      common /renorm/ Divergence, mudim, lambda, muscale
      common /renorm/ epscoeff, Finite, ESOFTMAX
      include "para.inc" 
c color factor

      averagefactor=1.d0/2.d0/nc

      results=0.d0
      if(p(0, 5).lt.ESOFTMAX) return

      do i=1, 5
      mm(i)=gm(p(0, i))
      pp(i)=max(dsqrt(p(1, i)**2+p(2, i)**2+p(3, i)**2), 1d-12)
      ex(i)=p(1, i)/pp(i)
      ey(i)=p(2, i)/pp(i)
      ez(i)=p(3, i)/pp(i)
      call VecSet(i, mm(i), pp(i), ex(i), ey(i), ez(i))
      enddo

      if(por.eq.-1) then
              helicities=2361674
      elseif(por.eq.1) then
              helicities=8653130
      else
              helicities=10750282
      endif


cc helicity amplitudes calculation

      call newSquaredME(results, helicities, flags)

      results=results*averagefactor/(2.d0*dsqrt(2.d0)*GF*mw**2)
      
      if(flags.ne.0) flags=0

      end subroutine
